#****************************************************************************
#**
#**  File     :  /cdimage/units/UAL0303/UAL0303_script.lua
#**  Author(s):  John Comes, David Tomandl
#**
#**  Summary  :  Aeon Siege Assault Bot Script
#**
#**  Copyright  2005 Gas Powered Games, Inc.  All rights reserved.
#****************************************************************************

local AWalkingLandUnit = import('/lua/aeonunits.lua').AWalkingLandUnit
local ADFLaserHighIntensityWeapon = import('/lua/aeonweapons.lua').ADFLaserHighIntensityWeapon
local EffectUtil = import('/lua/EffectUtilities.lua')
local Entity = import('/lua/sim/Entity.lua').Entity
local explosion = import('/lua/defaultexplosions.lua')
local EffectTemplate = import('/lua/EffectTemplates.lua')
local EffectUtilities = import('/lua/EffectUtilities.lua')
local Game = import('/lua/game.lua')
local utilities = import('/lua/utilities.lua')
local Shield = import('/lua/shield.lua').Shield
local UnitShield = import('/lua/shield.lua').UnitShield
local AntiArtilleryShield = import('/lua/shield.lua').AntiArtilleryShield
local Buff = import('/lua/sim/buff.lua')
local AIUtils = import('/lua/ai/aiutilities.lua')

--- shield fix by deadMG && Ze_PilOt
--- BEGIN MODIF

UAL0303 = Class(AWalkingLandUnit) {    
    Weapons = {
        FrontTurret01 = Class(ADFLaserHighIntensityWeapon) {}
    },
    HarbingerBugFixThread = function(self)
    while true do
      WaitTicks(1) 
        local aiBrain = self:GetAIBrain() 
          if aiBrain:GetEconomyStored('ENERGY') > 1 then 
               if self.MyShield.OffHealth == -1 then 
                   if self.MyShield:GetHealth() > 0 then 
                       self:SetCanTakeDamage(false) 
                   else 
                       self:SetCanTakeDamage(true) 
                   end 
               else 
                   self:SetCanTakeDamage(true) 
               end 
           else 
               self:SetCanTakeDamage(true) 
           end
        end
    end,
    OnCreate = function(self)
        AWalkingLandUnit.OnCreate(self)
        self:ForkThread(self.HarbingerBugFixThread)      
    end,
    CreateBuildEffects = function( self, unitBeingBuilt, order )
        EffectUtil.CreateAeonCommanderBuildingEffects( self, unitBeingBuilt, self:GetBlueprint().General.BuildBones.BuildEffectBones, self.BuildEffectsBag )
   end,    
}
--- END MODIF

TypeClass = UAL0303  